#! /usr/bin/env node

const { execSync } = require('child_process');
var colors = require('colors');

const runCommand = (cmd) => {
    try {
        execSync(cmd);
    } catch (error) {
        return false;
    }
    return true;
}

console.clear();
console.log(`
██████╗░██╗░██████╗░█████╗░░█████╗░██████╗░██████╗░  ░██████╗██╗░░░░░░█████╗░░██████╗██╗░░██╗
██╔══██╗██║██╔════╝██╔══██╗██╔══██╗██╔══██╗██╔══██╗  ██╔════╝██║░░░░░██╔══██╗██╔════╝██║░░██║
██║░░██║██║╚█████╗░██║░░╚═╝██║░░██║██████╔╝██║░░██║  ╚█████╗░██║░░░░░███████║╚█████╗░███████║
██║░░██║██║░╚═══██╗██║░░██╗██║░░██║██╔══██╗██║░░██║  ░╚═══██╗██║░░░░░██╔══██║░╚═══██╗██╔══██║
██████╔╝██║██████╔╝╚█████╔╝╚█████╔╝██║░░██║██████╔╝  ██████╔╝███████╗██║░░██║██████╔╝██║░░██║
╚═════╝░╚═╝╚═════╝░░╚════╝░░╚════╝░╚═╝░░╚═╝╚═════╝░  ╚═════╝░╚══════╝╚═╝░░╚═╝╚═════╝░╚═╝░░╚═╝
`.rainbow)
if (process.argv[2] === '-h' || process.argv[2] === '--help') {
    return console.log(`
    Usage: cloner [options]
    Options:
        -h, --help      Show this help message and exit.
        -v, --version   Show version number and exit.

    More Commands Soon!
        `);
}
console.log('Installing dependencies...'.green);
if (!runCommand('npm install colors')) {
    return console.log('Failed to install dependencies!'.red);
}
console.log("Creating Discord Bot Template..".green.bold);
console.log("Checking For Git & Node.js Installed.. ".yellow);
if (!runCommand('git --version')) {
    console.log("Git not is installed. Please install the latest version of git and try again.".red);
    return process.exit(1);
}
if (!runCommand('node --version')) {
    console.log("Node.js is not installed. Please install the latest version of node and try again.".red);
    return process.exit(1);
}

console.log("Cloning Discord Template.. ".green.bold);
if (runCommand('git clone https://github.com/RynsDev/Discord-Template-SLASH.git')) {
    console.log("Cloned Successfully!".green);
    console.log("Thanks for using my project! If it really helped, Make sure to leave a feedback!\nhttps://github.com/RynsDev/Discord-Template-SLASH".bold)
}
else {
    console.log("Failed to clone. Please try again.".red);
    return process.exit(1);
}
